<?php
/*
Plugin Name: Trainingstagebuch
Plugin URI: http://www.christianschenk.org/projects/wordpress-trainingstagebuch-plugin/
Description: Trainigsdaten in deinem Blog.
Version: 0.5
Author: Christian Schenk
Author URI: http://www.christianschenk.org/
*/

#
# WordPress Trainingstagebuch plugin
# Copyright (C) 2009 Christian Schenk
# 
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA
#


# Identifier fuer den Benutzernamen
define('OPTION_TRAININGSTAGEBUCH_USERNAME', 'trainingstagebuch_username');
# Identifier fuer das Passwort
define('OPTION_TRAININGSTAGEBUCH_PASSWORD', 'trainingstagebuch_password');
# Identifier fuer grosses/kleines BORG-Bild
define('OPTION_TRAININGSTAGEBUCH_BORG_IMAGE', 'trainingstagebuch_borg_image');


/**
 * Fuegt eine Seite 'Trainingstagebuch' in den Admin-Bereich ein.
 */
function trainingstagebuch_add_options_page() {
	if(function_exists('add_options_page'))
		add_options_page('Trainingstagebuch', 'Trainingstagebuch', 5, basename(__FILE__), 'trainingstagebuch_show_options_page');
}
if (function_exists('add_action')) add_action('admin_menu', 'trainingstagebuch_add_options_page');


/**
 * Verwaltet die Optionsseite
 */
function trainingstagebuch_show_options_page() {
	$username = get_option(OPTION_TRAININGSTAGEBUCH_USERNAME);
	$password = get_option(OPTION_TRAININGSTAGEBUCH_PASSWORD);
	$borg_img = get_option(OPTION_TRAININGSTAGEBUCH_BORG_IMAGE);

	if(isset($_POST['updateoptions'])) {
		$username = $_POST['username'];
		$password = $_POST['password'];
		$borg_img = $_POST['borg_img'];

		update_option(OPTION_TRAININGSTAGEBUCH_USERNAME, $username);
		update_option(OPTION_TRAININGSTAGEBUCH_PASSWORD, $password);
		update_option(OPTION_TRAININGSTAGEBUCH_BORG_IMAGE, $borg_img);

		echo '<div class="updated"><p><strong>'.__('Optionen gesichert', 'trainingstagebuch').'.</strong></p></div>';
	}
?>
<div class="wrap">
<h2>Trainingstagebuch</h2>
<form method="post" action="">
	<table width="100%" cellspacing="2" cellpadding="5" class="form-table">
		<tr valign="top">
			<th scope="row"><?php _e('Benutzername', 'trainingstagebuch'); ?>:</th>
			<td><input name="username" value="<?php echo $username; ?>" /></td>
		</tr>
		<tr valign="top">
			<th scope="row"><?php _e('Passwort', 'trainingstagebuch'); ?>:</th>
			<td><input name="password" value="<?php echo $password; ?>" /></td>
		</tr>
	</table>
<h3><?php _e('Optionen', 'trainingstagebuch'); ?></h3>
	<table width="100%" cellspacing="2" cellpadding="5" class="form-table">
		<tr valign="top">
			<th scope="row"><?php _e('Gr&ouml;&szlig;e des BORG-Bildes', 'trainingstagebuch'); ?>:</th>
			<td>
				<select name="borg_img">
      				<option <?php if ($borg_img == 'big') echo 'selected="selected" '; ?>value="big"><?php _e('gro&szlig;', 'trainingstagebuch'); ?></option>
      				<option <?php if ($borg_img == 'small') echo 'selected="selected" '; ?>value="small"><?php _e('klein', 'trainingstagebuch'); ?></option>
    			</select>
			</td>
		</tr>
	</table>
	<p class="submit">
		<input type="submit" name="updateoptions" value="<?php _e('Speichern', 'trainingstagebuch'); ?>" />
	</p>
</form>
<?php
if (!empty($username) and !empty($password)) {
	require_once('api/trainingstagebuch_api.php');
	$trainingstagebuch = new Trainingstagebuch($username, $password);
	$trainingstagebuchStatus = $trainingstagebuch->test();
	$cache = new TrainingstagebuchCache($trainingstagebuch);
	$cacheStatus = $cache->isSetUp();
?>
<h3><?php _e('Status', 'trainingstagebuch'); ?></h3>
	<table width="100%" cellspacing="2" cellpadding="5" class="form-table">
		<tr valign="top">
			<th scope="row"><?php _e('Verbindung API-Server', 'trainingstagebuch'); ?>:</th>
			<td><?php echo ($trainingstagebuchStatus === true) ? __('OK', 'trainingstagebuch') : __('Fehler', 'trainingstagebuch'); ?></td>
		</tr>
		<tr valign="top">
			<th scope="row"><?php _e('Cache', 'trainingstagebuch'); ?>:</th>
			<td><?php echo ($cacheStatus === true) ? __('OK', 'trainingstagebuch') : __('Fehler', 'trainingstagebuch'); ?></td>
		</tr>
	</table>
<?php } ?>
</div>
<?php
}

/*
 * Loescht alle Optionen aus der Datenbank.
 */
function trainingstagebuch_deactivate() {
	delete_option(OPTION_TRAININGSTAGEBUCH_USERNAME);  
	delete_option(OPTION_TRAININGSTAGEBUCH_PASSWORD);  
	delete_option(OPTION_TRAININGSTAGEBUCH_BORG_IMAGE);  
	delete_option('trainingstagebuch_widget');  
}
if (function_exists('add_action')) add_action('deactivate_trainingstagebuch/trainingstagebuch.php', 'trainingstagebuch_deactivate');


/*
 * Retrieves the tag cloud/list
 */
function trainingstagebuch_shortcode($atts, $content = NULL) {
	extract(shortcode_atts(array('type' => NULL, 'include' => NULL, 'exclude' => NULL,
	                             'year' => NULL, 'month' => NULL, 'week' => NULL, 'id' => NULL,
	                             'start' => NULL, 'end' => NULL), $atts));
	# sanity checks
	if (empty($type)) return '';

	$username = get_option(OPTION_TRAININGSTAGEBUCH_USERNAME);
	$password = get_option(OPTION_TRAININGSTAGEBUCH_PASSWORD);

	$rVal = '';
	try {
		require_once('api/trainingstagebuch_api.php');
		$trainingstagebuch = TrainingstagebuchFactory::produce($username, $password);

		$method = 'get_'.strtolower($type);
		if (is_callable(array('Trainingstagebuch', $method)) == false)
			throw new Exception("Typ '$type' unbekannt.");

		$result = NULL;
		if ($method == 'get_workout') {
			if (empty($id)) throw new Exception("Attribut 'id' fehlt.");
			$result = $trainingstagebuch->$method($id);
			# Wird nur ein einzelnes Workout angefragt, verpacken wir das noch
			# in einem 'exercise' Element
			$tmp->duration = $result->duration;
			$tmp->{'distance-km'} = $result->{'distance-km'};
			$tmp->exercise = array($result);
			$result = $tmp;
		} else if (strpos($method, 'year')) {
			if (empty($year)) throw new Exception("Attribut 'year' fehlt.");
			$result = $trainingstagebuch->$method($year);
		} else if (strpos($method, 'month')) {
			if (empty($year)) throw new Exception("Attribut 'year' fehlt.");
			if (empty($month)) throw new Exception("Attribut 'month' fehlt.");
			$result = $trainingstagebuch->$method($year, $month);
		} else if (strpos($method, 'week')) {
			if (empty($year)) throw new Exception("Attribut 'year' fehlt.");
			if (empty($week)) throw new Exception("Attribut 'week' fehlt.");
			$result = $trainingstagebuch->$method($year, $week);
		} else {
			$result = $trainingstagebuch->$method();
		}
		if (empty($result)) throw new Exception('Kein Ergebnis erhalten.');

#var_dump($result);

		if (strpos($method, 'workout') or strpos($method, 'plan')) {
			require_once('output.php');
			if (strpos($exclude, 'summary') === false) {
				$rVal .= get_exercise_summary($result);
			}

			$rVal .= get_exercises($result, $start, $end);
		}

	} catch(Exception $e) {
		return '<br>Fehler: '.$e->getMessage().'<br>';
	}

	return $rVal;
}
if (function_exists('add_shortcode'))
	foreach (array('tb', 'trainingstagebuch') as $shortcode)
		add_shortcode($shortcode, 'trainingstagebuch_shortcode');


/**
 * Displays widget.
 *
 * Supports multiple widgets.
 *
 * @param array $args Widget arguments.
 * @param array|int $widget_args Widget number. Which of the several widgets of this type do we mean.
 */
function widget_trainingstagebuch( $args, $widget_args = 1 ) {
	extract( $args, EXTR_SKIP );
	if ( is_numeric($widget_args) )
		$widget_args = array( 'number' => $widget_args );
	$widget_args = wp_parse_args( $widget_args, array( 'number' => -1 ) );
	extract( $widget_args, EXTR_SKIP );

	// Data should be stored as array:  array( number => data for that instance of the widget, ... )
	$options = get_option('widget_trainingstagebuch');
	if ( !isset($options[$number]) )
		return;

	echo $before_widget;

	switch ($options[$number]['typ']) {
	case 'banner_l':
		echo get_promo_banner('468_60');
		break;
	case 'banner_m':
		echo get_promo_banner('280_35');
		break;
	case 'banner_s':
		echo get_promo_banner('234_60');
		break;
	case 'badge_1':
		echo get_promo_banner('80_15');
		break;
	case 'badge_2':
		echo get_promo_banner('80_15_2');
		break;
	case 'text':
		$username = get_option(OPTION_TRAININGSTAGEBUCH_USERNAME);
		echo '<script language="JavaScript" src="http://trainingstagebuch.org/user/show/'.$username.'/javascript"></script>';
		break;
	case 'month':
		echo get_train_o_meter('month');
		break;
	case 'year':
		echo get_train_o_meter('year');
		break;
	default:
		_e('Fehler', 'trainingstagebuch');
	}

	echo $after_widget;
}


/**
 * Gibt ein Promotion-Banner aus.
 */
function get_promo_banner($type) {
	if (!in_array($type, array('468_60', '280_35', '234_60', '80_15', '80_15_2'))) return '';
	return '<a href="http://trainingstagebuch.org/" title="Kostenloses Trainingstagebuch und Trainingspläne"'.
	       '<img src="http://trainingstagebuch.googlepages.com/'.$type.'.jpg" alt="Trainingstagebuch.org" border="0" />'.
	       '</a>';
}


/**
 * Gibt ein Train-o-Meter aus.
 */
function get_train_o_meter($type) {
	if (!in_array($type, array('month', 'year'))) return '';
	$username = get_option(OPTION_TRAININGSTAGEBUCH_USERNAME);
	return '<a href="http://trainingstagebuch.org/user/show/'.$username.'" title="Mein Trainingstagebuch">'.
	       '<img src="http://trainingstagebuch.org/user/trainometer/'.$username.'/'.$type.'.png" alt="Train-O-Meter" border="0"/></a>';
}


/**
 * Displays form for a particular instance of the widget.
 *
 * Also updates the data after a POST submit.
 *
 * @param array|int $widget_args Widget number. Which of the several widgets of this type do we mean.
 */
function widget_trainingstagebuch_control( $widget_args = 1 ) {
	global $wp_registered_widgets;
	static $updated = false; // Whether or not we have already updated the data after a POST submit

	if ( is_numeric($widget_args) )
		$widget_args = array( 'number' => $widget_args );
	$widget_args = wp_parse_args( $widget_args, array( 'number' => -1 ) );
	extract( $widget_args, EXTR_SKIP );

	// Data should be stored as array:  array( number => data for that instance of the widget, ... )
	$options = get_option('widget_trainingstagebuch');
	if ( !is_array($options) )
		$options = array();

	// We need to update the data
	if ( !$updated && !empty($_POST['sidebar']) ) {
		// Tells us what sidebar to put the data in
		$sidebar = (string) $_POST['sidebar'];

		$sidebars_widgets = wp_get_sidebars_widgets();
		if ( isset($sidebars_widgets[$sidebar]) )
			$this_sidebar =& $sidebars_widgets[$sidebar];
		else
			$this_sidebar = array();

		foreach ( $this_sidebar as $_widget_id ) {
			// Remove all widgets of this type from the sidebar.  We'll add the new data in a second.  This makes sure we don't get any duplicate data
			// since widget ids aren't necessarily persistent across multiple updates
			if ( 'widget_trainingstagebuch' == $wp_registered_widgets[$_widget_id]['callback'] && isset($wp_registered_widgets[$_widget_id]['params'][0]['number']) ) {
				$widget_number = $wp_registered_widgets[$_widget_id]['params'][0]['number'];
				if ( !in_array( "trainingstagebuch-$widget_number", $_POST['widget-id'] ) ) // the widget has been removed. "trainingstagebuch-$widget_number" is "{id_base}-{widget_number}
					unset($options[$widget_number]);
			}
		}

		foreach ( (array) $_POST['widget-trainingstagebuch'] as $widget_number => $widget_trainingstagebuch_instance ) {
			// compile data from $widget_trainingstagebuch_instance
			if ( !isset($widget_trainingstagebuch_instance['typ']) && isset($options[$widget_number]) ) // user clicked cancel
				continue;
			$typ = wp_specialchars( $widget_trainingstagebuch_instance['typ'] );
			$options[$widget_number] = array( 'typ' => $typ );  // Even simple widgets should store stuff in array, rather than in scalar
		}

		update_option('widget_trainingstagebuch', $options);

		$updated = true; // So that we don't go through this more than once
	}


	// Here we echo out the form
	if ( -1 == $number ) { // We echo out a template for a form which can be converted to a specific form later via JS
		$typ = 'month';
		$number = '%i%';
	} else {
		$typ = attribute_escape($options[$number]['typ']);
	}

	// The form has inputs with names like widget-trainingstagebuch[$number][typ] so that all data for that instance of
	// the widget are stored in one $_POST variable: $_POST['widget-trainingstagebuch'][$number]
?>
		<p>
			<label for="widget-trainingstagebuch-typ-<?php echo $number; ?>">Typ:
				<select name="widget-trainingstagebuch[<?php echo $number; ?>][typ]">
    	  			<option <?php if ($typ == 'banner_l') echo 'selected="selected" '; ?>value="banner_l"><?php _e('Banner (gro&szlig;)', 'trainingstagebuch'); ?></option>
    	  			<option <?php if ($typ == 'banner_m') echo 'selected="selected" '; ?>value="banner_m"><?php _e('Banner (mittel)', 'trainingstagebuch'); ?></option>
    	  			<option <?php if ($typ == 'banner_s') echo 'selected="selected" '; ?>value="banner_s"><?php _e('Banner (klein)', 'trainingstagebuch'); ?></option>
    	  			<option <?php if ($typ == 'badge_1') echo 'selected="selected" '; ?>value="badge_1"><?php _e('Badge 1', 'trainingstagebuch'); ?></option>
    	  			<option <?php if ($typ == 'badge_2') echo 'selected="selected" '; ?>value="badge_2"><?php _e('Badge 2', 'trainingstagebuch'); ?></option>
    	  			<option <?php if ($typ == 'text') echo 'selected="selected" '; ?>value="text"><?php _e('Trainingsdaten als Text', 'trainingstagebuch'); ?></option>
    	  			<option <?php if ($typ == 'month') echo 'selected="selected" '; ?>value="month"><?php _e('Bild der Trainingsdaten (Monat)', 'trainingstagebuch'); ?></option>
    	  			<option <?php if ($typ == 'year') echo 'selected="selected" '; ?>value="year"><?php _e('Bild der Trainingsdaten (Jahr)', 'trainingstagebuch'); ?></option>
    			</select>
			</label>
			<input type="hidden" id="widget-trainingstagebuch-submit-<?php echo $number; ?>" name="widget-trainingstagebuch[<?php echo $number; ?>][submit]" value="1" />
		</p>
<?php
}

/**
 * Registers each instance of our widget on startup.
 */
function widget_trainingstagebuch_register() {
	if ( !$options = get_option('widget_trainingstagebuch') )
		$options = array();

	$widget_ops = array('classname' => 'widget_trainingstagebuch', 'description' => __('Infos aus dem Trainingstagebuch'));
	$control_ops = array('width' => 400, 'height' => 350, 'id_base' => 'trainingstagebuch');
	$name = __('Trainingstagebuch');

	$registered = false;
	foreach ( array_keys($options) as $o ) {
		// Old widgets can have null values for some reason
		if ( !isset($options[$o]['typ']) )
			continue;

		// $id should look like {$id_base}-{$o}
		$id = "trainingstagebuch-$o"; // Never never never translate an id
		$registered = true;
		wp_register_sidebar_widget( $id, $name, 'widget_trainingstagebuch', $widget_ops, array( 'number' => $o ) );
		wp_register_widget_control( $id, $name, 'widget_trainingstagebuch_control', $control_ops, array( 'number' => $o ) );
	}

	// If there are none, we register the widget's existance with a generic template
	if ( !$registered ) {
		wp_register_sidebar_widget( 'trainingstagebuch-1', $name, 'widget_trainingstagebuch', $widget_ops, array( 'number' => -1 ) );
		wp_register_widget_control( 'trainingstagebuch-1', $name, 'widget_trainingstagebuch_control', $control_ops, array( 'number' => -1 ) );
	}
}
if (function_exists('add_action')) add_action('widgets_init', 'widget_trainingstagebuch_register');

?>
